// Programm:  Schranken.cpp;
// Test der absoluten Fehlerschranken; 
// x aus X = [2^(54),pred(2^(55))]

#include "abs_relh.hpp" // Wegen abs_mulh1(),...
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <iostream>     // Wegen cout

using namespace cxsc;
using namespace std;

real absF(const real& x)
{
    interval x2,R;
    real msu,msd,d,del;
    dotprecision dot,dot1;
    dot = 1.0;
    dot = dot + x; // dot = 1+x;
    msu = addu(1.0,x); 
    msd = addd(1.0,x); 
    dot1 = dot;  // dot1 = dot = 1+x;
    dot = dot - msu; // dot: absoluter Fehler beim Aufrunden
    if (sign(dot)<0) {
        rnd(dot,d,RND_DOWN);
        d = abs(d);}
    else rnd(dot,d,RND_UP);

    dot1 = dot1 - msd; // dot: absoluter Fehler beim Abrunden
    if (sign(dot1)<0) {
        rnd(dot1,del,RND_DOWN);
        del = abs(del);}
    else rnd(dot1,del,RND_UP);
    if(d>del) del = d; // Maximumbildung

    return del;
}

int main()
{ 
    const real c = 3.0; // Zu testende abs. Fehlerschranke
    real a(comp(0.5,55)), b(pred(comp(0.5,56))); // X = [a,b]
    real del, x=a;

    do { 
        del = absF(x);
        if (del>c) {
            cout << "!!!!  del > c  !!!!" << endl;
            cout << SetPrecision(20,20) << "x = " << x << endl;
            cout << "del = " << del << endl;
            exit(1);
        };
        x = succ(x); }
    while (del<=c && x<=b);
}
