// Programm:  book_expl19.cpp
#include "abs_relh.hpp"   // Wegen abs_mulh4(), abs_mulh1()
#include "bnd_arh.hpp"    // Wegen rel_1px_delh()
#include "bnd_util.hpp"   // Wegen Max_bnd_Xi(), frac_tools()
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

interval x;  // Globale Variable x zur optimalen Einschlieung von 2/3
real a,del23,eps23;

real T_x(const interval& Xi, const real& epsx)
{
    interval P, P4, T;
    real eps,delP4,delT,delP;
    abs_mulh4(Xi,epsx,Xi,epsx,P,delP); // delP: abs. Fehler bzgl. x*x
    abs_mulh1(P,delP,P,delP,P4,delP4); 
                               // delP4: abs. Fehler bzgl. (x*x)*(x*x)    
    abs_mulh1(x,del23,P4,delP4,T,delT); 
                                  // delT: abs. Fehler bzgl. 2/3 * x^4
    rel_1px_delh(T,delT,P,eps); // eps : rel. Fehler bzgl. 1+2/3 * x^4
    return eps;  // Rckgabe einer Schranke eps des relativen Fehlers.
}

int main()
{
    frac_tools(2,3,x,a,del23,eps23);  // x schliet 2/3 optimal ein;
       // del23 ist relativer Datenfehler bei Rundung von 2/3 zur 
       // nchsten Rasterzahl a. del23 und a sind globale Variable 
    interval X;
    string("[1e-8,0.1]") >> X; // X: optim. Einschlieg. von[1e-8,0.1] 
    real bnd, diam = 1e-5, epsx=0;
    Max_bnd_Xi(T_x,X,epsx,diam,bnd);
    cout << RndUp << "Relative Fehlerschranke = " << bnd << endl; 
}
