// Programm sqrt1mx2_l.cpp zur Auswertung der Funktion
// sqrt(1-x^2) fr x vom Typ l_interval

#include <imath.hpp>
#include <l_imath.hpp>     
#include <iostream>

using namespace std;
using namespace cxsc;

l_interval Sqrt1mx2(const l_interval& x)
// sqrt(1-x^2);  Blomquist, 13.04.04;
{
    int stagsave = stagprec,
        stagmax = 19;
    l_interval y,z = abs(x);
    l_real r1,r2;
    interval dx = interval(z),
             einfachgenau;
    einfachgenau = sqrt1mx2(dx);
    if (stagprec>stagmax) stagprec = stagmax;

    if (stagprec == 1) y = sqrt1mx2(dx); // simple interval 
    else {
        y = comp(0.5,1023); // y = 2^(+1022)
        times2pown(z,511); 
        y = sqrt(y-z*z);
        times2pown(y,-511);
    } 
    stagprec = stagsave;
    y = adjust(y);
    y = y & einfachgenau;
    return y;
} // Sqrt1mx2

int main()
{
    stagprec = 19;
    l_interval x,y;
    real r;

    while (1) {
        cout << "real r = ?" << endl;   cin >> r;
        x = l_interval(r);  // x = x - MinReal;
        y = Sqrt1mx2(x);
        cout << SetDotPrecision(16*stagprec,16*stagprec) 
             << Scientific << "sqrt1mx2(x) = " << y << endl << endl;
    };
}
