// program sqrtp1m13.cpp calculating an approximation of sqrt(x+1)-1;
#include <iostream>   // for cout
#include <rmath.hpp>  // for sqrt()
using namespace cxsc;
using namespace std;

const real Sqrtp1m1_s = 9007199254740984.0 / 1125899906842624.0;
real Sqrtp1m1(const real& x) throw()
// Sqrtp1m1(x) = sqrt(x+1)-1;
{
    real y = x;
    int ex = expo(x);
    if (ex<=-50) times2pown(y,-1);  // |x|<2^(-50); fast division by 2 
    else if (ex>=105) y = sqrt(x);  // x >= 2^(+104) = 2.02824...e+31
    else if (ex>=53) y = sqrt(x)-1; // x >= 2^(+52)  = 4.50359...e+15
    else if (x>-0.5234375 && x<=Sqrtp1m1_s ) y = x / (sqrt(x+1) + 1);
    else y = sqrt(x+1)-1;
    return y;
}

int main()
{
    real x;
    while (1)
    {
        cout << "x = ? ";  cin >> RndNext >> x;
        cout << SetPrecision(16,16) << Scientific 
             << "sqrtp1m1(x) = " << Sqrtp1m1(x) << endl << endl;
    }
} // end of main
