// Programm:  sqrtx2m1_A4.cpp
// Berechnung des relativen Gesamtfehlers von:
// sqrt(x^2-1) approx x-1/(2*x)  fr x aus [44000,MaxReal]

#include "abs_relh.hpp" // Wegen abs_divh1()
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <iostream>     // Wegen cout

using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& delx)
{
    interval A,B;
    real app,rel,rela,delb;

    abs_divh1(interval(1),0.0,Xi,delx,A,app);  // A = 1/Xi
    abs_divh1(A,app,interval(2),0.0,B,delb);   // B = [1/Xi]/2
    rel_subh1(Xi,0.0,B,delb,A,rela);           // A = Xi - [1/Xi]/2
    // rela: relativer Auswertefehler von x - [1/x]/2
    // Berechnung des relativen Approximationsfehlers:
    B = Xi*Xi;
    A = 1 / (4*B*(B-1));
    app = Sup(A);  // app:  relativer Approximationsfehler
    // Bercksichtigung des Approximationsfehlers:
    rel  = addu(1.0,app);
    delb = mulu(rel,rela);
    rel  = addu(app,delb);
    return rel; // Rckgabe einer Schranke rel des rel. Gesamtfehlers.
}
int main()
{
    interval X = interval(44000,1e10);
    real bnd, diam = 1e-5, delx=0;  
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Relative Fehlerschranke = " << bnd << endl;
}
